[<prev] [next>] [thread-next>] [day] [month] [year] [list]
Message-ID: <bd55c0d5a90b35f7eeee6d132e950ca338ea1d67.1739895412.git.pablmart@redhat.com>
Date: Tue, 18 Feb 2025 17:19:28 +0100
From: Pablo Martin Medrano <pablmart@...hat.com>
To: netdev@...r.kernel.org
Cc: "David S . Miller" <davem@...emloft.net>,
Eric Dumazet <edumazet@...gle.com>,
Jakub Kicinski <kuba@...nel.org>,
Paolo Abeni <pabeni@...hat.com>,
Simon Horman <horms@...nel.org>,
Shuah Khan <shuah@...nel.org>,
Pablo Martin Medrano <pablmart@...hat.com>
Subject: [PATCH net] selftests/net: big_tcp: longer netperf session on slow machines
After debugging the following output for big_tcp.sh on a board:
CLI GSO | GW GRO | GW GSO | SER GRO
on on on on : [PASS]
on off on off : [PASS]
off on on on : [FAIL_on_link1]
on on off on : [FAIL_on_link1]
Davide Caratti found that by default the test duration 1s is too short
in slow systems to reach the correct cwd size necessary for tcp/ip to
generate at least one packet bigger than 65536 (matching the iptables
match on length rule the test evaluates)
This skips (with xfail) the aforementioned failing combinations when
KSFT_MACHINE_SLOW is set. For that the test has been modified to use
facilities from net/lib.sh.
The new output for the test will look like this (example with a forced
XFAIL)
Testing for BIG TCP:
CLI GSO | GW GRO | GW GSO | SER GRO
TEST: on on on on [ OK ]
TEST: on off on off [ OK ]
TEST: off on on on [XFAIL]
---
tools/testing/selftests/net/big_tcp.sh | 21 ++++++++++-----------
1 file changed, 10 insertions(+), 11 deletions(-)
diff --git a/tools/testing/selftests/net/big_tcp.sh b/tools/testing/selftests/net/big_tcp.sh
index 2db9d15cd45f..dc2ecfd58961 100755
--- a/tools/testing/selftests/net/big_tcp.sh
+++ b/tools/testing/selftests/net/big_tcp.sh
@@ -21,8 +21,7 @@ CLIENT_GW6="2001:db8:1::2"
MAX_SIZE=128000
CHK_SIZE=65535
-# Kselftest framework requirement - SKIP code is 4.
-ksft_skip=4
+source lib.sh
setup() {
ip netns add $CLIENT_NS
@@ -143,21 +142,20 @@ do_test() {
start_counter link3 $SERVER_NS
do_netperf $CLIENT_NS
- if check_counter link1 $ROUTER_NS; then
- check_counter link3 $SERVER_NS || ret="FAIL_on_link3"
- else
- ret="FAIL_on_link1"
- fi
+ check_counter link1 $ROUTER_NS
+ check_err $? "fail on link1"
+ check_counter link3 $SERVER_NS
+ check_err $? "fail on link3"
stop_counter link1 $ROUTER_NS
stop_counter link3 $SERVER_NS
- printf "%-9s %-8s %-8s %-8s: [%s]\n" \
- $cli_tso $gw_gro $gw_tso $ser_gro $ret
+ log_test "$(printf "%-9s %-8s %-8s %-8s" \
+ $cli_tso $gw_gro $gw_tso $ser_gro)"
test $ret = "PASS"
}
testup() {
- echo "CLI GSO | GW GRO | GW GSO | SER GRO" && \
+ echo " CLI GSO | GW GRO | GW GSO | SER GRO" && \
do_test "on" "on" "on" "on" && \
do_test "on" "off" "on" "off" && \
do_test "off" "on" "on" "on" && \
@@ -176,7 +174,8 @@ if ! ip link help 2>&1 | grep gso_ipv4_max_size &> /dev/null; then
fi
trap cleanup EXIT
+xfail_on_slow
setup && echo "Testing for BIG TCP:" && \
NF=4 testup && echo "***v4 Tests Done***" && \
NF=6 testup && echo "***v6 Tests Done***"
-exit $?
+exit $EXIT_STATUS
--
2.48.1
Powered by blists - more mailing lists